/**
 * 
 */
package ui;

import javax.swing.JFrame;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
import java.awt.*;

/**
 * @author Shane
 * Special thanks to Samir Vaidya's (mailto:syvaidya@gmail.com) OpenStego UI
 * I didn't know how to do the setActionCommands() using setActionCommand, Thanks.
 */
public class ThumbStegoFrame extends JFrame {
	
	public ThumbStegoFrame(){
		tabbedPane = new JTabbedPane();
		srcImgTextField = new JTextField();
		srcImgFileButton = new JButton();
		dataTextField = new JTextField();
		dataFileButton = new JButton();
		srcImg2TextField = new JTextField();
		srcImg2FileButton = new JButton();
		embThumbTextField = new JTextField();
		embThumbFileButton = new JButton();
		outputFileTextField = new JTextField();
		outputFileButton = new JButton();
		embedButton = new JButton();
		extractButton = new JButton();

		smallestButton = new JRadioButton("Smallest Possible", true);
		widthButton = new JRadioButton("Width");
		heightButton = new JRadioButton("Height");
		percentageButton = new JRadioButton("Percent");
		
        radioGroup = new ButtonGroup();
        radioGroup.add(smallestButton);
        radioGroup.add(widthButton);
        radioGroup.add(heightButton);
        radioGroup.add(percentageButton);
        
        widthTextField = new JTextField();
        heightTextField = new JTextField();
        percentageTextField = new JTextField();
		
		initComponents();
		setActionCommands();
	}
	
    /**
     * The tabbed pane for extraction or encryption.
     */
    protected JTabbedPane tabbedPane;
	
	/**
     * Text field for the location of the data to be encrypted.
     */
    protected JTextField srcImgTextField;
    /**
     * Button for selecting data to be encrypted.
     */
    protected JButton srcImgFileButton;

    /**
     * The text field for the source image.
     */
    protected JTextField dataTextField;

    /**
     * The button for the source image input.
     */
    protected JButton dataFileButton;

    /**
     * The embed button.
     */
    protected JButton embedButton;
    
	/**
     * Text field for the location of the data to be extracted.
     */
    protected JTextField srcImg2TextField;
    /**
     * Button for selecting data to be extracted.
     */
    protected JButton srcImg2FileButton;
    
    /**
     * The text field for the thumbnail with data embedded in it.
     */
    protected JTextField embThumbTextField;

    /**
     * The file button for the thumbnail with data embedded in it.
     */
    protected JButton embThumbFileButton;
    
    /**
     * The output filename text field
     */
    protected JTextField outputFileTextField;

    /**
     * The output filename folder button
     */
    protected JButton outputFileButton;

    /**
     * The extract button
     */
    protected JButton extractButton;
    
    
    
    	//These buttons are used to select the resizing method of the thumbnail
    protected ButtonGroup radioGroup;
    protected JRadioButton smallestButton;
    protected JRadioButton widthButton;
    protected JRadioButton heightButton;
    protected JRadioButton percentageButton;
    
    	//Text field for the radio buttons
    protected JTextField widthTextField;
    protected JTextField heightTextField;
    protected JTextField percentageTextField;
    
    
    
    
    /**
     * This initializes all of the components...
     */
    protected void initComponents(){
		
		GridBagConstraints gBC = null;
		JPanel mainPanel = new JPanel();
		JPanel embedPanel = new JPanel();
		JPanel extractPanel = new JPanel();
		JLabel label = null;
		
		
		//EXTRACT PANEL
		embedPanel.setLayout(new GridBagLayout());
		
		gBC = new GridBagConstraints();
		gBC.gridx = 0;
		gBC.anchor = GridBagConstraints.WEST;
		gBC.weightx = 1.0;
		gBC.weighty = 1.0;
		
		gBC.gridy = 0;
		label = new JLabel("Source Image");
		label.setLabelFor(srcImgTextField);
		embedPanel.add(label, gBC);
		
		srcImgTextField.setColumns(50);
		gBC.gridy = 1;
		embedPanel.add(srcImgTextField, gBC);
		
		gBC.gridy = 2;
		label = new JLabel("Data to embed");
		label.setLabelFor(dataTextField);
		embedPanel.add(label, gBC);
		
		dataTextField.setColumns(50);
		gBC.gridy = 3;
		embedPanel.add(dataTextField, gBC);
		
		
		gBC.gridx = 1;
		srcImgFileButton.setText("...");
		srcImgFileButton.setPreferredSize(new Dimension(30, 22));
		gBC.gridy = 1;
		embedPanel.add(srcImgFileButton, gBC);
		
		dataFileButton.setText("...");
		dataFileButton.setPreferredSize(new Dimension(30, 22));
		gBC.gridy = 3;
		embedPanel.add(dataFileButton, gBC);
		
		
			//The addition of the radio buttons		
		GridBagConstraints gBCRadio = new GridBagConstraints();
		gBCRadio.gridx = 0;
		gBCRadio.anchor = GridBagConstraints.WEST;
		gBCRadio.weightx = 1.0;
		gBCRadio.weighty = 1.0;
		
		JPanel radioButtonsPanel = new JPanel();
		
		radioButtonsPanel.setLayout(new GridBagLayout());
		
		radioButtonsPanel.setBorder(new TitledBorder("Size of thumbnail"));

			//Label
		/*gBCRadio.gridy = 0;
		gBCRadio.gridx = 0;
		label = new JLabel("Size of the thumbnail");
		label.setLabelFor(radioButtonsPanel);
		radioButtonsPanel.add(label, gBCRadio);*/

			//Buttons
			//Smallest Possible
		gBCRadio.gridx = 0;
		gBCRadio.gridy = 0;
		radioButtonsPanel.add(smallestButton, gBCRadio);
		
			//width
		gBCRadio.gridx = 1;
		gBCRadio.gridy = 0;
		radioButtonsPanel.add(widthButton, gBCRadio);

		gBCRadio.gridy = 1;
		widthTextField.setColumns(5);
		gBCRadio.anchor = GridBagConstraints.EAST;
		radioButtonsPanel.add(widthTextField, gBCRadio);
		gBCRadio.gridx = 2;
		gBCRadio.anchor = GridBagConstraints.WEST;
		radioButtonsPanel.add(new JLabel(" px"), gBCRadio);
		
		
			//height
		gBCRadio.gridx = 3;
		gBCRadio.gridy = 0;
		radioButtonsPanel.add(heightButton, gBCRadio);

		gBCRadio.gridy = 1;
		heightTextField.setColumns(5);
		gBCRadio.anchor = GridBagConstraints.EAST;
		radioButtonsPanel.add(heightTextField, gBCRadio);
		gBCRadio.gridx = 4;
		radioButtonsPanel.add(new JLabel(" px"), gBCRadio);
		gBCRadio.anchor = GridBagConstraints.WEST;
		
			//percent
		gBCRadio.gridy = 0;
		gBCRadio.gridx = 5;
		radioButtonsPanel.add(percentageButton, gBCRadio);

		gBCRadio.gridy = 1;
		percentageTextField.setColumns(5);
		gBCRadio.anchor = GridBagConstraints.EAST;
		radioButtonsPanel.add(percentageTextField, gBCRadio);
		gBCRadio.gridx = 6;
		radioButtonsPanel.add(new JLabel("(0.0 - 1.0)"), gBCRadio);
		gBCRadio.anchor = GridBagConstraints.WEST;

			//Radio Panel added to main
		gBC.gridx = 0;
		gBC.gridy = 4;
		embedPanel.add(radioButtonsPanel,gBC);

			//Add embed Button
		gBC.gridy = 5;
		embedButton.setText("Embed Data");
		embedPanel.add(embedButton,gBC);
		
		
		
		//EXTRACT PANEL
		
		extractPanel.setLayout(new GridBagLayout());
		
		gBC = new GridBagConstraints();
		gBC.gridx = 0;
		gBC.anchor = GridBagConstraints.WEST;
		gBC.weightx = 1.0;
		gBC.weighty = 1.0;
		
		gBC.gridy = 0;
		label = new JLabel("Source Image");
		extractPanel.add( label, gBC);
		
		gBC.gridy = 1;
		srcImg2TextField.setColumns(50);
		extractPanel.add(srcImg2TextField, gBC);
		
		gBC.gridy = 2;
		label = new JLabel("Embeded Thumbnail");
		extractPanel.add( label, gBC);
		
		gBC.gridy = 3;
		embThumbTextField.setColumns(50);
		extractPanel.add(embThumbTextField, gBC);
		
		gBC.gridy = 4;
		label = new JLabel("Output File");
		extractPanel.add( label, gBC);
		
		gBC.gridy = 5;
		outputFileTextField.setColumns(50);
		extractPanel.add(outputFileTextField, gBC);
		
		gBC.gridx = 1;
		
		gBC.gridy = 1;
		srcImg2FileButton.setText("...");
		srcImg2FileButton.setPreferredSize(new Dimension(30, 22));
		extractPanel.add(srcImg2FileButton, gBC);
		
		gBC.gridy = 3;
		embThumbFileButton.setText("...");
		embThumbFileButton.setPreferredSize(new Dimension(30, 22));
		extractPanel.add(embThumbFileButton, gBC);
		
		gBC.gridy = 5;
		outputFileButton.setText("...");
		outputFileButton.setPreferredSize(new Dimension(30, 22));
		extractPanel.add(outputFileButton, gBC);
		

		gBC.gridx = 0;
		gBC.gridy = 7;
		extractButton.setText("Extract Data");
		extractPanel.add(extractButton,gBC);
		
		
		//Adding extact and embed to the panel
		tabbedPane.addTab("Embed", embedPanel);
		tabbedPane.addTab("Extract", extractPanel);
		
		//Adding Tabbed panel to main panel
		mainPanel.add(tabbedPane);
		getContentPane().add(mainPanel, BorderLayout.CENTER);
		
        setTitle("Thumbnail Steganography");
        pack();
    }
    
    /**
     * Method to set the action commands for interactive UI items
     */
    protected void setActionCommands()
    {
    	srcImgFileButton.setActionCommand("BROWSE_SRC_IMG");
    	dataFileButton.setActionCommand("BROWSE_DATA");
        srcImg2FileButton.setActionCommand("BROWSE_SRC2_IMG");
        embThumbFileButton.setActionCommand("BROWSE_EMBEDED_THUMB");
        outputFileButton.setActionCommand("BROWSE_OUTPUT_FILE");
        embedButton.setActionCommand("EMBED");
        extractButton.setActionCommand("EXTRACT");
        
        smallestButton.setActionCommand("SMALLEST");
        widthButton.setActionCommand("WIDTH");
        heightButton.setActionCommand("HEIGHT");
        percentageButton.setActionCommand("PERCENTAGE");
    }
}
